#ifndef PROTOCOL_WLR_SCREENCOPY_UNSTABLE_V1_H
#define PROTOCOL_WLR_SCREENCOPY_UNSTABLE_V1_H

#include "symgen_types.h"
extern const struct wp_interface intf_wl_buffer;
extern const struct wp_interface intf_wl_output;
extern const struct wp_interface intf_zwlr_screencopy_frame_v1;
extern const struct wp_interface intf_zwlr_screencopy_manager_v1;
struct req_map_zwlr_screencopy_manager_v1 {
	wp_callfn_t capture_output;
	wp_callfn_t capture_output_region;
	wp_callfn_t destroy;
};
void do_zwlr_screencopy_frame_v1_req_copy(struct context *ctx, struct wp_object *buffer);
void call_zwlr_screencopy_frame_v1_req_copy(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
#define ZWLR_SCREENCOPY_FRAME_V1_ERROR_ALREADY_USED 0
#define ZWLR_SCREENCOPY_FRAME_V1_ERROR_INVALID_BUFFER 1
#define ZWLR_SCREENCOPY_FRAME_V1_FLAGS_Y_INVERT 1
void do_zwlr_screencopy_frame_v1_evt_ready(struct context *ctx, uint32_t tv_sec_hi, uint32_t tv_sec_lo, uint32_t tv_nsec);
void call_zwlr_screencopy_frame_v1_evt_ready(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
struct req_map_zwlr_screencopy_frame_v1 {
	wp_callfn_t copy;
	wp_callfn_t destroy;
	wp_callfn_t copy_with_damage;
};
struct evt_map_zwlr_screencopy_frame_v1 {
	wp_callfn_t buffer;
	wp_callfn_t flags;
	wp_callfn_t ready;
	wp_callfn_t failed;
	wp_callfn_t damage;
	wp_callfn_t linux_dmabuf;
	wp_callfn_t buffer_done;
};

#endif /* PROTOCOL_WLR_SCREENCOPY_UNSTABLE_V1_H */
